#ifdef SOLARIS
#define random lrand48
#define srandom srand48
#endif

#define MAXINT ((long)0x7fffffff)
#define ERROR (-MAXINT)

#define INIT_WIN_WID (640)
#define INIT_WIN_HGT (528)

#define TEXTLINE_HGT (24)
#define MSGLINE_HGT (24)
#define STATUSLINE_HGT (24)

#define EXTRASTUFF_HGT (72) /* sum of above */

#define STATE_GAME (-2)
#define STATE_HELD (-1)

#define PI     (3.1415926536)
#define TWOPI  (6.2831853072)
#define HALFPI (1.5707963268)

#define EVMASKS (ButtonPressMask | ButtonReleaseMask | KeyPressMask | ExposureMask | PointerMotionMask | StructureNotifyMask)

#define DEFAULTSIGFILE "/afs/andrew.cmu.edu/usr/what/xicehouse/lib/default.xice.sig"

#define sendmsg(obj) { (obj)->length = sizeof(*(obj)); write(server_socket, (char *)(obj), (obj)->length); }
#define esendmsg(obj, exsize) { (obj)->length = (exsize)+sizeof(*(obj)); write(server_socket, (char *)(obj), (obj)->length); }
#define ssendmsg(socknum, msg, len) { write(socknum, (char *)(msg), len); }

typedef struct _point {
    double x, y;
} point;

/* type for an arbitrary 4-sided area */
typedef struct _zone {
    double x, y; /* must be inside zone */
    point pts[4];
    double boundxmin, boundxmax, boundymin, boundymax;
} zone;

typedef struct _piece {
    short gamernum;
    short heldby;
    short size;
    short state, attack;
    double x, y;
    double rot;
} piece;

typedef struct _phand {
    point p;
    short holding;
    short placing;
} phand;

#ifdef lint
struct XKeytrans { int i; };
struct _XrmHashBucketRec { int i; };
struct _XStatistics { int i; };
struct _XRegion { int i; };
#endif /* lint */

extern void bcopy(), bzero(), /*srandom(),*/ free(), exit();
extern long random();
extern void *malloc();

#include "msgs.h"

extern int scn;
extern Display *dpy;
extern Window win;
extern GC blackgc, whitegc, flipgc, dottedgc; 
extern GC gamergc[MAXPLAYERS];
extern Pixmap backpm, icebitmap;

#define	MAJMODE_QUIT	(-1) /* quit now */
#define	MAJMODE_NOTIN	(0) /* title screen */
#define	MAJMODE_IN	(1) /* playing */
extern short majormode, playernum;
extern short numgamers;
extern short gamernum;
extern int win_wid, win_hgt, field_wid, field_hgt;


extern long tick;
extern int server_socket;
extern piece *pieces;
extern short numpieces;
extern short drawmode, cursormode;
extern short pieceheld;
extern point hand;
extern phand phands[MAXPLAYERS];

extern int lastscore[MAXPLAYERS];
extern short icehouselist[MAXPLAYERS];
extern short lastgameplayers, lastgameyou;

extern double locatx, locaty, scale;
extern double boardxmin, boardxmax, boardymin, boardymax;
extern double worldxmin, worldxmax, worldymin, worldymax;
extern zone *zones;
extern short numzones;

extern int reqoption[NUMOPTIONS], optionval[NUMOPTIONS];

extern siglist *sig;
extern short signumpieces;
extern point sigsize;
