#include <stdio.h>
#include <X11/Xlib.h>
#include "cli.h"

#include "gamer00.bm"
#include "gamer01.bm"
#include "gamer02.bm"
#include "gamer03.bm"
#include "gamer04.bm"
#include "gamer05.bm"
#include "gamer06.bm"
#include "gamer07.bm"
#include "gamer08.bm"
#include "gamer09.bm"
#include "gamer10.bm"
#include "gamer11.bm"

static char colnames[MAXPLAYERS][16] = {
    "blue1",
    "red",
    "limegreen",
    "yellow1",
    "magenta",
    "orange1",
    "grey69",
    "chocolate4",
    "pink",
    "cyan",
    "purple",
    "greenyellow"
};

/* make a whole bunch of color GC's. */
void setup_colors()
{
    int ix, res;
    XGCValues gcvalues;
    XColor col, sccol;

    for (ix=0; ix<MAXPLAYERS; ix++) {
	res = XAllocNamedColor(dpy, DefaultColormap(dpy, scn), colnames[ix], &col, &sccol);
	if (!res) {
	    fprintf(stderr, "unable to allocate color %s", colnames[ix]);
	    exit(-1);
	}
	gcvalues.foreground = col.pixel;
	gamergc[ix] = XCreateGC(dpy, win, GCForeground, &gcvalues);
    };
}

/* make a whole bunch of grey GC's. */
void setup_grey()
{
    Pixmap gamerpm[MAXPLAYERS];
    int ix;
    XGCValues gcvalues;
    int gamerpmwidth = 16;
    int gamerpmheight = 16;

    gamerpm[0] = XCreateBitmapFromData(dpy, win, gamer00_bits, gamerpmwidth, gamerpmheight);
    gamerpm[1] = XCreateBitmapFromData(dpy, win, gamer01_bits, gamerpmwidth, gamerpmheight);
    gamerpm[2] = XCreateBitmapFromData(dpy, win, gamer02_bits, gamerpmwidth, gamerpmheight);
    gamerpm[3] = XCreateBitmapFromData(dpy, win, gamer03_bits, gamerpmwidth, gamerpmheight);
    gamerpm[4] = XCreateBitmapFromData(dpy, win, gamer04_bits, gamerpmwidth, gamerpmheight);
    gamerpm[5] = XCreateBitmapFromData(dpy, win, gamer05_bits, gamerpmwidth, gamerpmheight);
    gamerpm[6] = XCreateBitmapFromData(dpy, win, gamer06_bits, gamerpmwidth, gamerpmheight);
    gamerpm[7] = XCreateBitmapFromData(dpy, win, gamer07_bits, gamerpmwidth, gamerpmheight);
    gamerpm[8] = XCreateBitmapFromData(dpy, win, gamer08_bits, gamerpmwidth, gamerpmheight);
    gamerpm[9] = XCreateBitmapFromData(dpy, win, gamer09_bits, gamerpmwidth, gamerpmheight);
    gamerpm[10] = XCreateBitmapFromData(dpy, win, gamer10_bits, gamerpmwidth, gamerpmheight);
    gamerpm[11] = XCreateBitmapFromData(dpy, win, gamer11_bits, gamerpmwidth, gamerpmheight);

    gcvalues.foreground = BlackPixel(dpy, scn);
    gcvalues.background = WhitePixel(dpy, scn);

    gcvalues.fill_style = FillOpaqueStippled;
    for (ix=0; ix<MAXPLAYERS; ix++) {
	gcvalues.stipple = gamerpm[ix];
	gamergc[ix] = XCreateGC(dpy, win, GCForeground|GCBackground|GCFillStyle|GCStipple, &gcvalues);
    };
}

