#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <sys/uio.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <X11/Xlib.h>
#include "cli.h"

#ifdef SOLARIS
#define memcpy memmove
#endif

extern int wait_for();
extern void process_buf(), take_server(), server_connect();

int server_socket;
/*char in_buf[MAXBUF];*/
msg_buffer mbuffer;
char *in_buf = (char *)(&mbuffer);
long in_pos;

void server_connect(servernm, initport)
char *servernm;
int initport;
{
    struct sockaddr_in server;
    struct hostent *hp;
    int port;

    for (port = initport; port<initport+10; port++) {

	server_socket = socket(AF_INET, SOCK_STREAM, 0);
	if (server_socket < 0) {
	    perror("attempt to open socket");
	    exit(-1);
	};


	server.sin_family = AF_INET;
	hp = gethostbyname(servernm);
	if (hp == NULL) {
	    printf("unknown host: %s\n", servernm);
	    exit(-1);
	};

	memcpy(&server.sin_addr, hp->h_addr, hp->h_length);

	server.sin_port = htons(port);

	if (connect(server_socket, &server, sizeof(server))>=0) {
	    printf("connected, port %d.\n", port);
	    return;
	}
	perror("connecting to socket");
	close(server_socket);
    }

    printf("giving up.\n");
    exit(-1);
}

/* the following is obsolete and unused */
int wait_for() /* returns -1 for incoming, or -2 for error */
{
    fd_set readbits, writebits, exbits;
    struct timeval timer;
    int ret;

    timer.tv_usec = 0;
    timer.tv_sec = 0;
    FD_ZERO(&readbits);
    FD_ZERO(&writebits);
    FD_ZERO(&exbits);
    FD_SET(server_socket, &readbits);
    ret = select(server_socket+1, &readbits, &writebits, &exbits, (struct timeval *)NULL);
    if (FD_ISSET(server_socket, &readbits)) return (-1);
    return (-2);
}

void take_server() /* take data from server */
{
    int rval, ix, done;
    int msglen;
    char *ptr;

    rval = read(server_socket, (in_buf+in_pos), (int)(MAXBUF-(in_pos)));
    if (rval < 0) {
	perror("reading stream message");
	in_pos = 0;
    }
    else {
	if (rval == 0) {
	    /* create illusion of a crash message */
	    msg_crash msg;
	    msg.length = sizeof(msg);
	    msg.type = mtype_crash;
	    process_buf(&msg, sizeof(msg));
	}
	else {
/*printf("inpos = %d; rval = %d\n", in_pos, rval);*/
	    in_pos += rval;
	    ptr = in_buf;
	    msglen = *((int *)ptr);
	    done = 0;
	    while (!done && ptr+msglen <= in_buf+in_pos) {
		process_buf(ptr, msglen);
		ptr += msglen;
		if (ptr == in_buf+in_pos) {
		    done = 1;
		}
		else {
		    msglen = *((int *)ptr);
		}
	    }
	    for (ix=0; ix<((in_buf+in_pos)-ptr); ix++)
		in_buf[ix] = ptr[ix];
	    in_pos = ix;
	}
    }
}

