#define MAXINT ((long)0x7fffffff)
#define ERROR (-MAXINT)

#define MAJMODE_NIL (-1) /* nothing attached */
#define MAJMODE_NOTIN (0) /* at entry screen */
#define MAJMODE_IN (1) /* playing a game */

#define STATE_GAME (-2)
#define STATE_HELD (-1)

#define GMODE_START (0)
#define GMODE_GAME (1)

#define PI     (3.1415926536)
#define TWOPI  (6.2831853072)
#define HALFPI (1.5707963268)

#define ZEROPIECESIZE (1.03125)
#define PIECESIZEDIFF (0.65625) 

#define PLACE_OK (0)
#define PLACE_CRASH (1)
#define PLACE_ZONEEDGE (2)
#define PLACE_OFFBOARD (3)
#define PLACE_FOREIGNSTASH (4) /* ok if player crashed, etc. */
#define PLACE_STASH (5) /* ok *unless* crashed, etc. */
#define PLACE_ATTACK_NOTHING (6) /* ok in advanced rules */
#define PLACE_ATTACK_ATTACK (7)
#define PLACE_ATTACK_SELF (8)
#define PLACE_MELTDOWN (9)
#define PLACE_NODECRASH (10)
#define PLACE_CONFLICT (11)

#define LIFT_OK (0)
#define LIFT_FOREIGNSTASH (1)
#define LIFT_ATT_OVERICE (2) /* usually ok @#@ remember new-walls case! */
#define LIFT_DEF_BAD (3) /* def piece on board */
#define LIFT_ATT_NOTYOURS (4) /* att piece attacking somebody else's def piece */
#define LIFT_ATT_OWNCOLOR (5) /* att piece attacking a def piece of its own color */
#define LIFT_ATT_NOTOVERICE (6) /* att piece attacking a non-overiced def piece */
#define LIFT_ATT_NOTARGET (7) /* att piece attacking nothing */
#define LIFT_ATT_TARGETATT (8) /* att piece attacking attack piece */


#define sendmsg(rcli, obj) { (obj)->length = sizeof(*(obj)); write(clients[rcli]->sock_num, (char *)(obj), (obj)->length); }

#define gsendmsg(gamr, obj) if (gamers[gamr].playernum!=(-1)) { (obj)->length = sizeof(*(obj)); write(gamers[gamr].sock_num, (char *)(obj), (obj)->length); }

#define esendmsg(rcli, obj, exsize) { (obj)->length = (exsize)+sizeof(*(obj)); write(clients[rcli]->sock_num, (char *)(obj), (obj)->length); }

#define gesendmsg(gamr, obj, exsize) if (gamers[gamr].playernum!=(-1)) { (obj)->length = (exsize)+sizeof(*(obj)); write(gamers[gamr].sock_num, (char *)(obj), (obj)->length); }

#define ssendmsg(socknum, msg, len) { write(socknum, (char *)(msg), len); }

#include "msgs.h"

typedef long clref; /* "pointer" to object in clients[] list */

typedef struct _point {
    double x, y;
} point;

/* type for an arbitrary 4-sided area */
typedef struct _zone {
    double x, y; /* must be inside zone */
    point pts[4];
    double boundxmin, boundxmax, boundymin, boundymax;
} zone;

typedef struct _game_client {
    char in_buf[MAXBUF];
    int sock_num;
    long in_pos;
    short quit_flag;
    char host_name[40];
    int playernum;
} game_client;

typedef struct _pler {
    short gamernum; /* only significant within a game */
    short majormode;
    short reqoption[NUMOPTIONS];
    siglist *sig;
    short signumpieces;
    point sigsize;
    char name[16], userid[8];
} pler;

typedef struct _gamer {
    int sock_num; 
    short playernum; /* -1 when connection is fried */
    short crashed; /* flag */
    short meltstatus; /* starts at 2, drops when a defensive piece is played */
    short icehoused; /* flag */
    short holding;
    short placing;
    short stashlimit;
    short score; /* not used until end-of-game */
    point hand;
    zone pad; 
} gamer;

typedef struct _piece {
    short gamernum;
    short size;
    short state;
    short heldby; 
    short attack;
    short score; /* not used until end-of-game */
    double x, y;
    double rot;
    point pts[4];
    double boundxmin, boundxmax, boundymin, boundymax;
} piece;

extern clref connections;   /* number of active connections, also first free spot in clients[] */
extern clref active_client;  /* index into clients[] */
extern game_client *clients[MAXPLAYERS];

extern pler plers[MAXPLAYERS]; /* indexed by playernum */

extern long tick;
extern short numgamers;
extern int gamemode;
extern gamer *gamers;
extern piece *pieces;
extern zone board;
extern double worldxmin, worldxmax, worldymin, worldymax;
extern short numpieces;
extern int optionval[NUMOPTIONS];

extern long random();
extern void exit(), bcopy(), free();/*, srandom();*/
extern void *malloc();
