#include <stdio.h>
#include <math.h>
#include "ser.h"

static msg_buffer buf;

void run_tick()
{
    int pnum, gx, cx;
    msg_stick *msg = (msg_stick *)(&buf);

    /*printf("tik\n");*/
    if (gamemode == GMODE_START) {

	msg->numgamers = connections;

	/* send to everybody */
	msg->type = mtype_stick;
	for (cx=0; cx<connections; cx++) {
	    sendmsg(cx, msg);
	}

    }
    else {
	/* put data into stick for each gamer */
	for (gx=0; gx<numgamers; gx++) {
	    msg->s[gx].x = gamers[gx].hand.x;
	    msg->s[gx].y = gamers[gx].hand.y;
	    msg->s[gx].piecenum = gamers[gx].holding;
	    if (gamers[gx].holding != (-1)) {
		msg->s[gx].rot = pieces[gamers[gx].holding].rot;
		msg->s[gx].attack = pieces[gamers[gx].holding].attack;
	    }
	}
	msg->numgamers = numgamers;

	/* send to everybody */
	msg->type = mtype_stick;
	for (gx=0; gx<numgamers; gx++) {
	    gesendmsg(gx, msg, numgamers*sizeof(struct msg_status_pler));
	}
    }

    tick++;
}

void take_cupdate(msg)
msg_cupdate *msg;
{
    msg_piecestatus backup;
    int plernum = clients[active_client]->playernum;
    int gnum = plers[plernum].gamernum;
    int piecenum = gamers[gnum].holding;
    int ix, gx;

    gamers[gnum].hand.x = msg->handx;
    gamers[gnum].hand.y = msg->handy;

    if (piecenum != (-1))
    {
	if (optionval[OPT_USE_PLACING_MODE]) {
	    backup.type = mtype_piecestatus;
	    backup.piecenum = piecenum;
	    backup.gamernum = gnum;
	    backup.state = STATE_HELD;
	    backup.attack = pieces[piecenum].attack;
	    backup.x = pieces[piecenum].x;
	    backup.y = pieces[piecenum].y;
	    backup.rot = pieces[piecenum].rot;
	}

	pieces[piecenum].x = msg->handx;
	pieces[piecenum].y = msg->handy;
	pieces[piecenum].rot = msg->rot;
	pieces[piecenum].attack = msg->attack;


	if ( (optionval[OPT_USE_PLACING_MODE]) && (gamers[gnum].placing) )
	{   /* check for piece-overlap with all the placed or placing pieces */
	compute_piece(piecenum, pieces[piecenum].x, pieces[piecenum].y, pieces[piecenum].rot, pieces[piecenum].attack );
	    for (ix = 0; ix<numpieces; ix++)
	    {
		if (ix != piecenum && ( (pieces[ix].state == STATE_GAME) || ((pieces[ix].state == STATE_HELD) && (gamers[pieces[ix].heldby].placing)) ) )
		{
		    if (piece_overlap(&(pieces[piecenum]), &(pieces[ix])))
		    {
			msg_piececrash msg;

			if (pieces[ix].state == STATE_HELD)
			{
			    /* Bounced into other piece in placing mode--back up */
			    gamers[gnum].hand.x = backup.x;
			    gamers[gnum].hand.y = backup.y;
			    pieces[piecenum].x = backup.x;
			    pieces[piecenum].y = backup.y;
			    pieces[piecenum].rot = backup.rot;
			    pieces[piecenum].attack = backup.attack;
			    compute_piece(piecenum, pieces[piecenum].x, pieces[piecenum].y, pieces[piecenum].rot, pieces[piecenum].attack );

			    gsendmsg(gnum, &backup);
			    return;
			}
			/* Crashed into played piece */
			msg.type = mtype_piececrash;
			msg.flag = 1;
			msg.gamernum = gnum;
			gamers[gnum].crashed = 1;
			gamers[gnum].placing = 0;
			/* broadcast fact of crashing */
			for (gx=0; gx<numgamers; gx++)
			    gsendmsg(gx, &msg);
			return; /* disallow placement */
		    }
		}
	    }
	}
    }
}
